function [ fk ] = z_deblurSingleChannel(img, filterSize, processType, numIteration, beginPercent, endPercent, pBegin, pEnd )

% CANNOT HANDLE DISK FILTERS YET

% fk      : resulting image
% hk      : resulting filter
[N, M]=size(img);

mask=zeros(N*2, M*2);

mask(ceil(N/2)+1:ceil(N/2)+N,ceil(M/2)+1:ceil(M/2)+M)=1;

blurredMask = conv2(mask, z_createFilter('gaussian', filterSize, filterSize),'same');

img = padarray(img, [ceil(N/2) ceil(M/2)], 'replicate', 'pre');
img = padarray(img, [floor(N/2) floor(M/2)], 'replicate', 'post');

g = img .* blurredMask;

N = 2 * N;
M = 2 * M;

G = fft2(g, N, M);

fk = zeros(N, M);
fk(1, 1) = 1;
Fk = fft2(fk, N, M);
filtermask=zeros(N, M);


filtermask(round(N/2-filterSize/2):round(N/2+filterSize/2),...
    round(M/2-filterSize/2):round(M/2+filterSize/2))=1;
filtermask=fftshift(filtermask);

hk=filtermask;
hk=hk/sum(sum(hk));
Hk=fft2(hk,N,M);
Fk_1=Fk;
a=0.09;

k=1;

%%%%%%%%%%%%%%%  PHASE BASED PART  %%%%%%%%%%%%%%%
angles=angle(fft2(img));
% anglemask=zeros(N);
anglemask=ones(N,M);
%anglemask(N/2-zerophasesize:N/2+zerophasesize+1,N/2-zerophasesize:N/2+zerophasesize+1)=1;
%anglemask=anglemask>0.5;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

step = (numIteration / (endPercent - beginPercent));




while k < numIteration

    %FFT%%%%%%%
    Fk=fft2(fk,N,M);
%%%%%%%%%%%%%%%  PHASE BASED PART  %%%%%%%%%%%%%%%
if(strcmp(processType,'AyersPhase') || strcmp(processType,'AyersPhaseTV'))
    Fk(anglemask)=abs(Fk(anglemask)).*exp(1i*angles(anglemask));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%%
    
    
    %Impose fourier constraints
    Hk_1=Hk;
    Hk=(G.*conj(Fk_1))./(abs(Fk_1).^2+a./(abs(Hk_1).^2));
    %%%%%%%%%%%
    
    
    %IFFT%%%%%%
    hk = real(ifft2(Hk,N,M));    
%     Hkk = abs(fft2(hk,N,N));
%     hk = real(ifft2(Hkk,N,N));
    %%%%%%%%%%%
    
    %Impose BLUR constraints
    hk = hk.*filtermask;
    hk(hk<0)=0;
%%%%%%%%%%%%%%%        PESC        %%%%%%%%%%%%%%%
% burada hk zerine PES yada PES-L1 uygulanacak
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    hk=hk/sum(sum(hk));
    %%%%%%%%%%
    
    %FFT%%%%%%
    Hk=fft2(hk,N,M);
    %%%%%%%%%%
    
    
    %Impose fourier constraints
    Fk_1=Fk;
    Fk=(G.*conj(Hk_1))./(abs(Hk_1).^2+a./(abs(Fk_1).^2));
%%%%%%%%%%%%%%%  PHASE BASED PART  %%%%%%%%%%%%%%%
if(strcmp(processType,'AyersPhase') || strcmp(processType,'AyersPhaseTV'))
    Fk(anglemask)=abs(Fk(anglemask)).*exp(1i*angles(anglemask));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%
    
    %IFFT%%%%%
    fk=real(ifft2(Fk,N,M));
%%%%%%%%%%%%%%%  PHASE BASED PART  %%%%%%%%%%%%%%%
if(strcmp(processType,'AyersPhase') || strcmp(processType,'AyersPhaseTV'))
    fk=fk.*mask;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%
    
    
    %impose image constraints
    fk(fk>1)=1;
    fk(fk<0)=0;
%%%%%%%%%%%%%%%        PESC        %%%%%%%%%%%%%%%
if(strcmp(processType,'AyersTV') || strcmp(processType,'AyersPhaseTV'))
    if k>(numIteration - 50)
%       call pesc algorithm
        fk=PESC(fk);
%         run('z_pesc_files\run_pesc.m');
    end
end
% burada fk zerine PESC uygulanacak

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%%%%%%%%%
    k=k+1;
    if(floor(k/step) > floor((k-1)/step))
        processSoFar = (k / numIteration) * pEnd + (1 - (k / numIteration)) * pBegin;
        durationSoFar = toc;
        elapsedTime = z_duration(durationSoFar);
        remainingTime =  z_duration(((1-processSoFar) * durationSoFar) / (processSoFar));
        disp([num2str(beginPercent + floor(k/step)) '% complete. ' ...
            'Elapsed Time: ' elapsedTime ' ' ...
            'Remaining Time: ' remainingTime]);
    end
end
fk=fk(round(N/4+1):round(3*N/4),round(M/4+1):round(3*M/4));
%hk=fftshift(hk);
%hk=hk(N/2-N/4+1:N/2+N/4,N/2-N/4+1:N/2+N/4);



end

