
disp(['Reading elements from folder: ' inputsFolder]);

files = z_getFiles(inputsFolder, imageExtension);

numFiles = sum(files == '/') - 1;

disp([num2str(numFiles) ' files found.']);

seperatorPositions = find(files == '/');

tic;
processArray = { 'AyersOnly', 'AyersPhase', 'AyersTV', 'AyersPhaseTV'};
for ii = 1:numFiles
    for mm = 1:4
        processType = char(processArray(mm));
        disp(['Processing image ' num2str(ii)  ' of ' num2str(numFiles)]);
        fileName = files(seperatorPositions(ii)+1:seperatorPositions(ii+1)-1);
        img = double(imread([inputsFolder '/' fileName]))/255;
        %blur images and write to folder 
        if (false == areImagesBlurry)
            filter = z_createFilter(filterType, filterRadiusSigma, filterSize);
            img = z_blurImage(img, filter, areImagesRGB);
        end
        imwrite(img, [blurryFolder '/' fileName]);

        %used to display time information
        processBegin = ((mm-1)*numFiles + ii-1)/(numFiles * 4);
        processEnd = ((mm-1)*numFiles + ii)/(numFiles * 4);
        %deblur images using given params
        img  = z_deblur(img, filterSize, processType, areImagesRGB, numIterations, processBegin, processEnd);

        imwrite(img, [outputsFolder '/' processType '/' fileName]);

    end  
    
end